
C  *****************************************************************************
C  *                                                                           *
C  *                *****     SUBROUTINE PFTCC_FILL_G     *****                *
C  *                                                                           *
C  *    READ IN THE ENTIRE DATA SET OF POLAR FFTS FOR THE CHOSEN               *
C  *     SEARCH WINDOW.                                                        *
C  *                                                                           *
C  *    DECEMBER 1987  PURDUE UNIVERSITY VAX 11/750, T. BAKER                  *
C  *    MAY 1992  PURDUE UNIVERSITY VAX 8550, J. TESMER.                       *
C  *    Moved THETA,PHI calculations to CALC_MOD_TPS, 30 Jan 1997, D. Belnap   *
C  *    MODIFIED 19-DEC-1997 BY T. BAKER (Some output stuff).                  *
C  *    MODIFIED 23-DEC-1997 BY T. BAKER (Using memory for PFTS).              *
C  *    MODIFIED 14-JAN-1998 BY TSB/RWA (*.PIF input of PFTs/PRJs).            *
C  *    MODIFIED  6-MAR-1998 BY TSB (Make UNIX compatible).                    *
C  *    MODIFIED 27-APR-1998 BY TSB (Make GLOBAL compatible).                  *
C  *    LAST MODIFIED 24-JUL-2002 BY TSB (PFTs no longer store on disk).       *
C  *****************************************************************************
C
      SUBROUTINE PFTCC_FILL_G (PFTS, PFT_AVGS, NROT, NANNULI, 
     1     NVIEW_MOD, SQ2, JCUT, PIXRES_MIN, PIXRES_MAX, ANN_LO, ANN_HI, 
     2     VAR, RMS, AVER, VAROPT, SIGCUT)
C     
      IMPLICIT NONE

      INTEGER*4 NROT, NANNULI, NVIEW_MOD, J, JN, K, JCUT, J2
      INTEGER*4 ANN_LO, ANN_HI, IR, R, NUM, VAR((NROT/4),NANNULI)
      INTEGER*4 NROT_BY_4
      REAL*4    RMS((NROT/4),NANNULI), AVER((NROT/4),NANNULI)
      REAL*4    PFTS((NROT/4),NANNULI,NVIEW_MOD)
      REAL*4    TMP2, SIGCUT, PIXRES, PIXRES_MIN, PIXRES_MAX
      REAL*4    PFT_AVGS(NVIEW_MOD), PTS, AVE, AVE2
      REAL*4    PI, TWOPIR, SQ2(NVIEW_MOD)
      LOGICAL   VAROPT
C  ----------------------------------------------------------------------------
C
      pi = acos(-1.0)
      NROT_BY_4 = NROT/4
      J2        = NROT_BY_4 - 1
        PTS       = 0.0
C
      DO K = 1,NVIEW_MOD
        PTS = 0.0
        DO IR = ANN_LO,ANN_HI
          R      = MIN(NANNULI, IR+1)
          TWOPIR = 2.0*PI*FLOAT(IR)
          DO JN = JCUT,J2
            IF(JN.GT.0) THEN                        ! TRAP FOR Jo
               PIXRES = TWOPIR/FLOAT(JN)
             ELSE
               PIXRES = 1000.0
            ENDIF
C     Replace obsolete goto ... enddo with f90 CYCLE
            IF(PIXRES.LT.PIXRES_MAX .OR. PIXRES.GT.PIXRES_MIN) CYCLE !RSS
            J    = JN + 1
            PTS  = PTS + 1.0
              TMP2 = PFTS(J,R,K)
              IF(VAROPT) THEN
                AVER(J,R) = AVER(J,R) + TMP2
                VAR(J,R)  = 0
              ENDIF
           ENDDO
        ENDDO
      ENDDO                                      ! DO K = 1,NVIEW_MOD
C
        AVE2 = 0.0
        IF(VAROPT) THEN
        DO IR = ANN_LO,ANN_HI
          R      = MIN(NANNULI, IR+1)
          TWOPIR = 2.0*PI*FLOAT(IR)
          DO JN = JCUT,J2
            IF(JN.GT.0) THEN                              ! TRAP FOR Jo
               PIXRES = TWOPIR/FLOAT(JN)
             ELSE
               PIXRES = 1000.0
            ENDIF
C     Replace obsolete goto ... enddo with f90 CYCLE
            IF(PIXRES.LT.PIXRES_MAX .OR. PIXRES.GT.PIXRES_MIN) CYCLE !RSS
            J        = JN + 1
              RMS(J,R) = 0.0
            AVE      = AVER(J,R)/FLOAT(NVIEW_MOD)
              DO K = 1,NVIEW_MOD
                TMP2     = PFTS(J,R,K)
                RMS(J,R) = RMS(J,R) + (TMP2-AVE)**2
            ENDDO
              RMS(J,R) = SQRT(RMS(J,R)/NVIEW_MOD)
              AVE2     = AVE2 + RMS(J,R)
           ENDDO
        ENDDO
          NUM  = 0
          AVE2 = AVE2/PTS
        DO IR = ANN_LO,ANN_HI
          R      = MIN(NANNULI, IR + 1)
          TWOPIR = 2.0*PI*FLOAT(IR)
          DO JN = JCUT,J2
            IF(JN.GT.0) THEN                        ! TRAP FOR Jo
               PIXRES = TWOPIR/FLOAT(JN)
             ELSE
               PIXRES = 1000.0
            ENDIF
C     Replace obsolete goto ... enddo with f90 CYCLE
            IF(PIXRES.LT.PIXRES_MAX .OR. PIXRES.GT.PIXRES_MIN) CYCLE !RSS
            J = JN + 1
              IF (RMS(J,R).GT.SIGCUT*AVE2) THEN
                VAR(J,R) = 1
                NUM      = NUM + 1 
              ENDIF
           ENDDO
        ENDDO

        PRINT *,'VARIANCE:'
        PRINT *,'USING POINTS > ',SIGCUT,'*',AVE2
        PRINT *,'POINTS FROM PFFT BEING USED: ',NUM
        ENDIF

      DO K = 1,NVIEW_MOD
        PTS         = 0.0
        PFT_AVGS(K) = 0.0
          SQ2(K)      = 0.0
        DO IR = ANN_LO,ANN_HI
          R      = MIN(NANNULI, IR+1)
          TWOPIR = 2.0*PI*FLOAT(IR)
          DO JN = JCUT,J2
            IF(JN.GT.0) THEN                        ! TRAP FOR Jo
               PIXRES = TWOPIR/FLOAT(JN)
             ELSE
               PIXRES = 1000.0
            ENDIF
C     Replace obsolete goto ... enddo with f90 CYCLE
            IF(PIXRES.LT.PIXRES_MAX .OR. PIXRES.GT.PIXRES_MIN) CYCLE !RSS
            J = JN + 1
              IF((VAROPT.AND.(VAR(J,R).ne.0)) .OR. .NOT.VAROPT) THEN
              PTS         = PTS + 1.0
                TMP2        = PFTS(J,R,K)
              PFT_AVGS(K) = PFT_AVGS(K) + TMP2
              SQ2(K)      = SQ2(K) + TMP2**2
              ENDIF
           ENDDO
        ENDDO
        PFT_AVGS(K) = PFT_AVGS(K)/PTS
      ENDDO

      RETURN
      END
